package com.abernal.prizy

import grails.transaction.Transactional

@Transactional
class FirstProductService implements ProductServiceInterface{

    def BigDecimal getAveragePrice(Long productId) {

        BigDecimal averagePrice = 0


        List<Price> prices = Price.withCriteria {
            product {
                eq 'id', productId
            }
        }

        if (prices.size() != 0 ){

            prices.each { price -> averagePrice += price.price }
            averagePrice = averagePrice/prices.size()

        }else{
            averagePrice = 0
        }

        return  averagePrice

    }

    def BigDecimal getLowestPrice(Long productId) {

        BigDecimal lowestPrice = 0

        def query = Price.where {
            product.id == productId
        }

        def result = query.find(max:1, sort:'price', order: 'asc')

        if (result != null ){
            lowestPrice = result.price
        }

        return lowestPrice

    }

    def BigDecimal getHighestPrice(Long productId) {

        BigDecimal highestPrice = 0

        def query = Price.where {
            product.id == productId
        }

        def result = query.find(max:1, sort:'price', order: 'desc')

        if(result != null){
            highestPrice = result.price
        }

        return highestPrice
    }

    def BigDecimal getIdealPrice(Long productId) {

        BigDecimal idealPrice = 0
        def elementsDiscarted = 4

        def query = Price.where {
            product.id == productId
        }

        def list = query.list(sort:'price', order: 'desc')

        if ( list.size() > elementsDiscarted) {
            def counter = 0
            for (price in list){
                if (!(counter == 0 || counter == 1 || counter == list.size() - 2 || counter == list.size() - 1)){
                    idealPrice += price.price
                }
                counter++
            }

            idealPrice = idealPrice/(list.size()-elementsDiscarted)
            idealPrice += idealPrice * 0.2
        }else{
            idealPrice = 0
        }

        return idealPrice

    }

    def Integer getNumberOfPricesCollected(Long productId) {
        def query = Price.where {
            product.id == productId
        }

        return query.count()
    }
}
