package com.abernal.prizy



import spock.lang.*

/**
 *
 */
class FirstProductServiceSpec extends Specification {

    def productService

    void "test LowestPrice"() {

        when:
            def productA = new Product(name: "Nuevo", barcode: "123456", description: "Un gran producto")
            def priceA = new Price(store: "Integration Store", price: 100, notes: "Some Notes", product: productA)
            def priceB = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceC = new Price(store: "Integration Store", price: 200, notes: "Some Notes", product: productA)

            productA.save()
            priceA.save()
            priceB.save()
            priceC.save()

        then:
            productService.getLowestPrice(productA.id) == 100

    }

    void "test HighestPrice"() {

        when:
            def productA = new Product(name: "Nuevo", barcode: "123456", description: "Un gran producto")
            def priceA = new Price(store: "Integration Store", price: 100, notes: "Some Notes", product: productA)
            def priceB = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceC = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceD = new Price(store: "Integration Store", price: 200, notes: "Some Notes", product: productA)
            def priceE = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)

            productA.save()
            priceA.save()
            priceB.save()
            priceC.save()
            priceD.save()
            priceE.save()
        then:
            productService.getHighestPrice(productA.id) == 200

    }

    void "test AveragePrice"() {

        when:
            def productA = new Product(name: "Nuevo", barcode: "123456", description: "Un gran producto")
            def priceA = new Price(store: "Integration Store", price: 100, notes: "Some Notes", product: productA)
            def priceB = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceC = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceD = new Price(store: "Integration Store", price: 200, notes: "Some Notes", product: productA)
            def priceE = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)

        productA.save()
            priceA.save()
            priceB.save()
            priceC.save()
            priceD.save()
            priceE.save()
        then:
            productService.getAveragePrice(productA.id) == 150

    }

    void "test idealPrice"() {

        when:
            def productA = new Product(name: "Nuevo", barcode: "123456", description: "Un gran producto")
            def priceA = new Price(store: "Integration Store", price: 100, notes: "Some Notes", product: productA)
            def priceB = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceC = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceD = new Price(store: "Integration Store", price: 200, notes: "Some Notes", product: productA)
            def priceE = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)

            productA.save()
            priceA.save()
            priceB.save()
            priceC.save()
            priceD.save()
            priceE.save()
        then:
            productService.getIdealPrice(productA.id) == 180

    }

    void "test numberOfPricesCollected"() {

        when:
            def productA = new Product(name: "Nuevo", barcode: "123456", description: "Un gran producto")
            def priceA = new Price(store: "Integration Store", price: 100, notes: "Some Notes", product: productA)
            def priceB = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceC = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)
            def priceD = new Price(store: "Integration Store", price: 200, notes: "Some Notes", product: productA)
            def priceE = new Price(store: "Integration Store", price: 150, notes: "Some Notes", product: productA)

            productA.save()
            priceA.save()
            priceB.save()
            priceC.save()
            priceD.save()
            priceE.save()
        then:
            productService.getNumberOfPricesCollected(productA.id) == 5

    }
}
