--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET search_path = public, pg_catalog;

--
-- Name: hibernate_sequence; Type: SEQUENCE; Schema: public; Owner: abernal
--

CREATE SEQUENCE hibernate_sequence
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE hibernate_sequence OWNER TO abernal;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: price; Type: TABLE; Schema: public; Owner: abernal; Tablespace: 
--

CREATE TABLE price (
    id bigint NOT NULL,
    version bigint NOT NULL,
    notes character varying(255) NOT NULL,
    price numeric(19,2) NOT NULL,
    product_id bigint NOT NULL,
    store character varying(255) NOT NULL
);


ALTER TABLE price OWNER TO abernal;

--
-- Name: product; Type: TABLE; Schema: public; Owner: abernal; Tablespace: 
--

CREATE TABLE product (
    id bigint NOT NULL,
    version bigint NOT NULL,
    barcode integer NOT NULL,
    description character varying(255),
    name character varying(255) NOT NULL
);


ALTER TABLE product OWNER TO abernal;

--
-- Name: price_pkey; Type: CONSTRAINT; Schema: public; Owner: abernal; Tablespace: 
--

ALTER TABLE ONLY price
    ADD CONSTRAINT price_pkey PRIMARY KEY (id);


--
-- Name: product_pkey; Type: CONSTRAINT; Schema: public; Owner: abernal; Tablespace: 
--

ALTER TABLE ONLY product
    ADD CONSTRAINT product_pkey PRIMARY KEY (id);


--
-- Name: fk_emiuohuwtefgg9mcjqiu5uota; Type: FK CONSTRAINT; Schema: public; Owner: abernal
--

ALTER TABLE ONLY price
    ADD CONSTRAINT fk_emiuohuwtefgg9mcjqiu5uota FOREIGN KEY (product_id) REFERENCES product(id);


--
-- Name: public; Type: ACL; Schema: -; Owner: abernal
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM abernal;
GRANT ALL ON SCHEMA public TO abernal;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

